#ifndef _SHA256_H
#define _SHA256_H

#ifndef uint8
#define uint8  unsigned char
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

typedef struct
{
    uint32 total[2];
    uint32 state[8];
    uint8 buffer[64];
}
sha256_context;

void sha256_starts( sha256_context *ctx );
void sha256_update( sha256_context *ctx, uint8 *input, uint32 length );
void sha256_finish( sha256_context *ctx, uint8 digest[32] );
//void sha2_hmac( unsigned char *key, int keylen, unsigned char *input, int ilen, unsigned char output[32], int is224 );
//void sha2_hmac_finish( sha2_context *ctx, unsigned char output[32] );
//void sha2_hmac_update( sha2_context *ctx, unsigned char *input, int ilen );
//void sha2_hmac_starts( sha2_context *ctx, unsigned char *key, int keylen, int is224 );

#endif /* sha256.h */

